<?
	include "funclib.php";
	include "redisFunc.php";

	//----------------------------------------------------------------------------------------------------------------------
	// 先載入 keyword 定義
	//----------------------------------------------------------------------------------------------------------------------
	$keyword = "../ptt/keyword.txt";
	if( !($fp=fopen($keyword,"r")) )
		exit;
	
	$aKeyWord = array();
	while( !feof($fp) )
	{
		$str = trim(fgets($fp,128));
		if( $str=="" )
			continue;
			
		if( !isset($aKeyWord[$str]) )
			array_push($aKeyWord, $str);
	}
	fclose($fp);

	$today  = mktime(0,0,0,date("m"),date("d"),date("Y"));

	redis_conn();
	$ch = curl_init();

	//----------------------------------------------------------------------------------------------------------------------
	// 尋找出mobile01熱門版
	//----------------------------------------------------------------------------------------------------------------------
	//$html = curl("http://www.mobile01.com/hottopics.php", $ch);
	$html = curl("http://www.mobile01.com/newtopics.php?p=1",$ch);

	$aa = explode("<td class=\"subject\">",$html);
	unset( $aa[0] );
	
	foreach( $aa as $block )
	{
		$bb = explode("class=\"",$block);
		$title = $link = $date = $author = $dd = "";
		foreach( $bb as $str )
		{
			if( is_numeric(strpos($str, "topic_gen")) )
			{
				$n1 = strpos($str, ">")+1;
				$n2 = strpos($str, "<");
				$title = substr($str,$n1,$n2-$n1);
			}

			if( is_numeric(strpos($str, "authur")) )
			{
				$n = strpos($str,"<a href=");
				$str = substr($str,$n+9);
				$cc = explode("<p>",$str);
				if( count($cc)!=3 )
					continue;
					
				$n = strpos($cc[0],"\"");

				$link = "http://www.mobile01.com/".substr($cc[0],0,$n);
				
				$date = strip_tags( $cc[1] );
				$author = trim( strip_tags( $cc[2] ) );

				$matches = array();
				preg_match("([1-2][0-9][0-9][0-9]-[0-1][0-9]-[0-3][0-9] [0-2][0-9]:[0-5][0-9])",$date, $matches);
				
				if( count($matches)<1 )
					continue;
					
				$date = $matches[0];
			}
		}
		
		if( $title=="" || $link=="" || $date=="" || $author=="" )
				continue;

		$dd = DateTime::createFromFormat("Y-m-d H:i",$date);
		$y = date_format($dd, "Y");
		$m = date_format($dd, "m");
		$d = date_format($dd, "d");
		$h = date_format($dd, "H");
		$i = date_format($dd, "i");
		$date = mktime($h,$i,0,$m,$d,$y);

		// 超過3天不檢查
		if( ($today-$date) > $check_date )
			continue;

		// 3天內的 先檢查 key 是否存在
		$date = date("Y/m/d H:i",$date);
		$n = strpos($link,"?");
		$para = substr($link,$n+1);
		$key = "mobile01:".$date.":".$para;
		
		//echo date("Y/m/d H:i:s")." $key [$author] $title --> $link\n";

		if( redis_exists($key) )
			continue;

		// 寫入redis, 避免下次再檢查
		redis_set($key,"");

		// 開始下載 文章內容 並等待6秒鐘避免被封鎖

		$html = curl($link,$ch);
		
		$title = str_replace("&#33;","!" ,$title);
		$title = str_replace("&#34;","\"",$title);
		$title = str_replace("&quot;","\"",$title);
		$title = str_replace("&#35;","#" ,$title);
		$title = str_replace("&#36;","$" ,$title);
		$title = str_replace("&#37;","%" ,$title);
		$title = str_replace("&#38;","&" ,$title);
		$title = str_replace("&#39;","'" ,$title);
		$title = str_replace("&amp;","&" ,$title);
		$title = str_replace("&lt;" ,"<" ,$title);
		$title = str_replace("&gt;" ,">" ,$title);

		$title = str_replace("&#033;","!" ,$title);
		$title = str_replace("&#034;","\"",$title);
		$title = str_replace("&#035;","#" ,$title);
		$title = str_replace("&#036;","$" ,$title);
		$title = str_replace("&#037;","%" ,$title);
		$title = str_replace("&#038;","&" ,$title);
		$title = str_replace("&#039;","'" ,$title);
		
		sleep(6);
		echo date("Y/m/d H:i:s")." $key [$author] $title --> $link\n";
		
		$n1   = strpos($html,"<main>");
		$n2   = strpos($html,"</main>");
		$html = substr($html,$n1, $n2-$n1);
		$bb   = explode("<div class=\"single-post-content\">",$html);
		$html = "";
		foreach( $bb as $str )
			$html.= strip_tags($str);
			
		// 過濾關鍵字
		$flag = false;
		$ids = "";
		// 尋找關鍵字 momo 富邦 包含 link 都找
		$aKey = array("momo","ｍｏｍｏ","富邦購物","摩天商城","富邦媒","標錯價");
		$word = search_Keyword( $aKey, $html, $title );
		if( $word!="" )
		{
			// 00144  00316  02037  01170  04825  05059  00046
	    // 林合壎 李孟和 何銘華 鄭仁智 吳文熙 吳康德 蕭斯鎮
			$ids = "momo_keyword";
			$flag = true;
		}
		else
		{
			// 尋找 自訂關鍵字 keyword.txt 
			$word = search_Keyword( $aKeyWord, $html, $title );
			if( $word!="" )
			{
				//     鄭仁智
				$ids = "01170";
				$flag = true;
				if( $word=="汐止" )
				{
					//     鄭仁智 倪其伸
					$ids = "01170,04228";
				}
				elseif( $word=="pchome" || $word=="物流" )
				{
					// 04369 王莉蓉
					$ids = "04369";
				}
			}
		}

		if( !$flag || $ids=="" )
			continue;
						
		$gcmMsg = str_replace("www.mobile01.com", "m.mobile01.com", $link);
		
		if( $ids=="" )
			$ids = "01170";
		
		if( $word!="" )
			$ok = sendGCM( "mobile01", $ids, $gcmMsg, substr($date,5)."【".$author."】".$word."\n標題:".$title );
		else
			$ok = sendGCM( "mobile01", $ids, $gcmMsg, substr($date,5)."【".$author."】\n標題:".$title );
				
		echo date("Y/m/d H:i:s")." mobile01 ---> [$title] [$link] [$date] [$author] $word --> $link [$ok]\n\n";
	}
	
	curl_close($ch);
	redis_close();
	
?>