<?
	include "funclib.php";

	// GCM qH
	$empId = "01170";

	//-----------------------------------------------------------------------------------------------
	// Ū dns.conf ]w
	//-----------------------------------------------------------------------------------------------
	if( !($fp=fopen("dns.conf","r")) )
	{
		echo "not found dns.conf\n";
		exit;
	}

	echo "\n".date("Y/m/d H:i:s")."\n";

	$aDOMAIN = array();
	$aCOUNT  = array();
	while( !feof($fp) )
	{
		$str = trim( fgets($fp,256) );
		if( $str=="" )
			continue;
		
		if( substr($str,0,1)=="#" )
			continue;
			
		$aa = explode("\t",$str);
		if( count($aa)!=2 )
			continue;

		$domain = trim( $aa[0] );
		$ip     = trim( $aa[1] );
		if( !isset($aDOMAIN[$domain]) )
		{
			$aDOMAIN[$domain] = "";
			$aCOUNT[$domain]  = 0;
		}
		
		if( instr($aDOMAIN[$domain], $ip)>0 )
			continue;
		
		$aDOMAIN[$domain] = $aDOMAIN[$domain] . " " . $ip;
		$aCOUNT[$domain]  = $aCOUNT[$domain] + 1;
	}
	fclose($fp);
	
	//-----------------------------------------------------------------------------------------------
	// Ū alias.conf ]w
	//-----------------------------------------------------------------------------------------------
	if( !($fp=fopen("alias.conf","r")) )
	{
		echo "not found alias.conf\n";
		exit;
	}
	
	$aALIAS = array();
	while( !feof($fp) )
	{
		$str = trim( fgets($fp,256) );
		if( $str=="" )
			continue;

		if( substr($str,0,1)=="#" )
			continue;
		
		$aa = explode("\t",$str);
		if( count($aa)!=2 )
			continue;

		$domain = trim( $aa[0] );
		$alias  = trim( $aa[1] );
		if( $domain==$alias )
			continue;

		// ˬd domain O_sb $aDOMAIN
		if( !isset($aDOMAIN[$domain]) )
		{
			$msg = "[".$alias."] alias config ".$domain." not found";
			echo $msg."\n";
			sendGCM( $msg );
			continue;
		}
		$aALIAS[$alias] = $domain;
	}
	fclose($fp);
	
	// ˬdC@domain	
	foreach( $aDOMAIN as $domain => $ips )
	{
		$aIP = array();
		$max = $aCOUNT[$domain] * 3;
		for( $i=0; $i<$max; $i++ )
		{
			for( $j=0; $j<3; $j++ )
			{
				$str = osCommand("host $domain | grep address");
				if( $str!="" )
					break;
					
				if( $str=="" && $j==2 )
				{
					$msg = "[".$domain."] dns no answer";
					//echo $msg."\n";
					//sendGCM( "[".$domain."] dns no answer" );
					break;
				}
				sleep(1);
			}
			
			$aa = explode("\n",$str);
			foreach( $aa as $str )
			{
				if( $str=="" )
					continue;
					
				$n = instr($str,"address");
				if( $n<0 )
					continue;
					
				$ip = substr($str,$n+8);
				
				if( !in_array($ip,$aIP) )
					array_push($aIP,$ip);
			}
			
			sleep(0.2);
			
		}
		
		// }lˬddomain ip O_b]wɤ $aDOMAIN[]
		foreach( $aIP as $ip )
		{
			// $ips odomainҦip
			if( instr($ips,$ip)<1 )
			{
				if( $ip=="60.251.113.76" )
					continue;
					
				$msg = "[".$ip."] not in ".$domain;
				echo $msg."\n";
				sendGCM( $msg );
			}
		}
	}


	// ˬdC@ alias  ip O_sb]w $aDOMAIN[]
	foreach( $aALIAS as $alias => $domain )
	{
		// T{ domain O_sb
		if( !isset( $aDOMAIN[ $domain ] ) )
			continue;

		$ips = $aDOMAIN[ $domain ];
		$aIP = array();
		$max = $aCOUNT[$domain];
		for( $i=0; $i<$max; $i++ )
		{
			for( $j=0; $j<3; $j++ )
			{
				$str = osCommand("host $alias | grep address");
				if( $str!="" )
					break;
					
				if( $str=="" && $j==2 )
				{
					$msg = "alias [".$alias."] dns no answer";
					//echo $msg."\n";
					//sendGCM( $msg );
					break;
				}
				sleep(1);
			}
			
			$aa = explode("\n",$str);
			foreach( $aa as $str )
			{
				if( $str=="" )
					continue;
					
				$n = instr($str,"address");
				if( $n<0 )
					continue;
					
				$ip = substr($str,$n+8);
				
				if( !in_array($ip,$aIP) )
					array_push($aIP,$ip);
			}
			sleep(0.2);
		}
		
		// }lˬddomain ip O_b]wɤ $aDOMAIN[]
		foreach( $aIP as $ip )
		{
			// $ips odomainҦip
			if( !isset( $aDOMAIN[ $domain ] ) )
				continue;
			
			if( instr($ips,$ip)<1 )
			{
				$msg = "alias [".$alias."] ".$ip." not in ".$domain;
				echo $msg."\n";
				sendGCM( $msg );
			}
		}
	}

	
	//---------------------------------------------------------------------
	// oe GCM qH
	//---------------------------------------------------------------------
	function sendGCM( $message="" )
	{
		global $empId;
		if( $empId=="" || $message=="" )
			return;
		
		curlSend( "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT", $empId, $message );
	}
?>