<?
	include "funclib.php";
	include "redisFunc.php";
	
	$ip_list = "ip_list.txt";
	if( !file_exists($ip_list) )
		exit;

	$now  = time();
	$last = filemtime($ip_list);

	if( date("i",$now)!="00" )
	{
		// 上次修改時間 如超過60秒 就離開
		if( ($now-$last)>60 )
			exit;
	}

	//-----------------------------------------------------------------------------------------------
	// 開始讀取 ip_list.txt 轉入 redis
	//-----------------------------------------------------------------------------------------------
	
	redis_conn();
	
	// 先刪除 存在 redis的ip
	$aa = redis_keys("ip:*");
	delete_ip( $aa );
	
	// 先刪除 存在 redis的ip
	$aa = redis_keys("gw:*");
	delete_ip( $aa );
	
	$str = file_get_contents("ip_list.txt");
	$str = str_replace("\r","",$str);
	$str = str_replace("\"","",$str);
	$aa = explode("||",$str);
	$aIP = array();
	$aGW = array();
	foreach( $aa as $str )
	{
		$str = iconv("BIG5", "UTF-8", $str);
		$bb = explode("\t", ltrim($str));
		if( count($bb)!=6 )
			continue;

		if( substr($bb[0],0,1)=="#" )
			continue;
			
		$domain  = $bb[0];
		$ip      = $bb[1];
		$gateway = $bb[2];
		$line_no = $bb[3];
		$call_no = str_replace("\n","、",$bb[4]);
		$call_no = trim($call_no);

		if( $ip=="60.251.113.76" )
			continue;

		if( verify_ip( $ip ) )
		{	
			$key = "ip:$ip";
			$val = "$domain\t$line_no\t$call_no";
			redis_set($key,$val,86400);
		}

		if( verify_ip( $gateway ) )
		{
			$key = "gw:$gateway";
			$val = "$domain\t$line_no\t$call_no";
			redis_set($key,$val,86400);
		}
	}
	redis_close();
	exit;

	// 檢查 ip 是否正確
	function verify_ip( $ip="" )
	{
		if( substr($ip,0,8)=="192.168." )
			return 0;
		
		$valid = preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\z/', $ip);
		
		return $valid;
	}

	function delete_ip( $aa=array() )
	{
		foreach( $aa as $key )
			redis_del( $key, 0, 60 );
	}
	
?>