<?
include "redisFunc.php";

// EC_APP 首頁
$ecapp_url= "http://www.momoshop.com.tw/api/moecapp/api/limitBuy/list";

redis_conn();
$ch = curl_init();

$page = $pageSize = 0;
for( $page=0; $page<=$pageSize; $page++ )
{
	$postData = json_encode( array("pageIndex" => $page), JSON_FORCE_OBJECT);
	$response = curl_post_call($ecapp_url, $postData);
	$obj = json_decode ( $response );
	
	var_dump($obj);
	continue;

	if( $page==0 )
	{
		$pageSize = $obj->{"pageSize"};
		if( intval($pageSize)<=0 )
			break;
		continue;
	}
	
	if( !isset( $obj->{"success"} ) )
		continue;

	if( !$obj->{"success"} )
		continue;
	
	if( !isset( $obj->{"mainInfo"} ) )
		continue;

	$max = count($obj->{"mainInfo"});
	// var_dump( $obj->{"mainInfo"} );

	$aType = array(
	 1 => "edm",
	 2 => "menu",
	 3 => "title",
	 4 => "loud1",
	 5 => "loud2",
	 6 => "banner1",
	 7 => "banner2",
	 8 => "banner3",
	 9 => "goods1",
	10 => "goods2_limit",
	11 => "goods2_normal",
	12 => "goods3",
	13 => "other"
	);
	foreach( $obj->{"mainInfo"} as $mainInfo )
	{
		if( !isset($mainInfo->{"type"}) )
			continue;
			
		// 取得 首頁排版類型
		$type  = $mainInfo->{"type"};
		$ctype = $aType[$type];
		
		foreach( $mainInfo as $info )
		{
			if( is_numeric($info) )
				continue;

			$max = count($info);
			for( $i=0; $i<$max; $i++ )
			{
				//echo "type($type)=$ctype ";
				switch($type)
				{
					case 1: // edm
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【$type edm】圖片錯誤" );
						curl( $link   , "【$type edm】連結錯誤" );
						// echo "[edm][$i] $picture -> $link\n";
						break;
						
					case 2: // menu
						if( !isset($info[$i]->{"menu"}->{"menuName"}) )
							break;
						$menuName = $info[$i]->{"menu"}->{"menuName"};
						$menuIcon = $info[$i]->{"menu"}->{"menuIcon"};
						$link     = $info[$i]->{"action"}->{"actionValue"};
						curl( $menuIcon, "【$type menu】$menuName Icon錯誤" );
						curl( $link    , "【$type menu】$menuName 連結錯誤" );
						//echo "[menu][$i] $menuName $menuIcon -> $link\n";
						break;
						
					case 3: // 限時搶購 今日秒殺 ... BAR
						if( !isset($info[$i]->{"title"}->{"picture"}) )
							break;
						$picture    = $info[$i]->{"title"}->{"picture"};
						curl( $picture, "【$type title】圖片錯誤" );
						// echo "$picture\n";
						break;
						
					case 4: // loud1 熱門快訊
						if( !isset($info[$i]->{"loud"}->{"loudIcon"}) )
							break;
							
						$loudIcon = $info[$i]->{"loud"}->{"loudIcon"};
						$title    = $info[$i]->{"loud"}->{"title"};
						$subTitle = $info[$i]->{"loud"}->{"subTitle"};
						$link     = $info[$i]->{"action"}->{"actionValue"};
						curl( $link    , "【$type loud1】$title 熱門快訊 連結錯誤" );
						// echo "[loud1][$i] $title $subTitle -> $loudIcon -> $link\n";
						break;
						
					case 5: // loud2 大聲公
						if( !isset($info[$i]->{"loud"}->{"loudIcon"}) )
							break;
						$loudIcon = $info[$i]->{"loud"}->{"loudIcon"};
						$title    = $info[$i]->{"loud"}->{"title"};
						$subTitle = $info[$i]->{"loud"}->{"subTitle"};
						$link     = $info[$i]->{"action"}->{"actionValue"};
						$link     = "http://m.momoshop.com.tw/goods.momo?i_code=".$link;
						curl( $link    , "【$type loud2】$title 大聲公商品頁 連結錯誤" );
						// echo "[loud2][$i] $title $subTitle -> $loudIcon -> $link\n";
						break;
						
					case 6: // banner1 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【$type banner1】活動 圖片錯誤" );
						curl( $link   , "【$type banner1】活動 連結錯誤" );
						// echo "[banner1][$i] $picture -> $link\n";
						break;
						
					case 7: // banner2 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【$type banner2】活動 圖片錯誤" );
						curl( $link   , "【$type banner2】活動 連結錯誤" );
						// echo "[banner2][$i] $picture -> $link\n";
						break;
						
					case 8: // banner3 活動
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						curl( $picture, "【$type banner3】活動 圖片錯誤" );
						curl( $link   , "【$type banner3】活動 連結錯誤" );
						// echo "[banner3][$i] $picture -> $link\n";
						break;
						
					case 9: // goods1
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name      = $info[$i]->{"mainGoods"}->{"name"};
						$subTitle  = $info[$i]->{"mainGoods"}->{"subTitle"};
						$picture   = $info[$i]->{"mainGoods"}->{"picture"};
						if( strlen($goodsCode)==6 || strlen($goodsCode)==7 )
							$link = "http://m.momoshop.com.tw/goods.momo?i_code=".$goodsCode;
						else
							$link = $goodsCode;

						//echo "[goods1][$i] $name $subTitle -> $picture -> $link\n";
						curl( $picture, "【$type goods1】$name 精選推薦 圖片錯誤" );
						curl( $link   , "【$type goods1】$name 精選推薦 連結錯誤" );
						break;
						
					case 10: // goods2_limit 限時搶購
						if( !isset($info[$i]->{"limitBuyItem"}->{"fsCode"}) )
							break;
						$fsCode    = $info[$i]->{"limitBuyItem"}->{"fsCode"};
						$goodsCode = $info[$i]->{"limitBuyItem"}->goods->{"goodsCode"};
						$name      = $info[$i]->{"limitBuyItem"}->goods->{"name"};
						$picture   = $info[$i]->{"limitBuyItem"}->goods->{"picture"};
						
						$matches = array();
						preg_match("([1-2][0-1][0-9][0-9][0-1][0-9][0-3][0-9])",$fsCode, $matches);
						if( count($matches)<1 )
							continue;
						$dir = $matches[0];
						
						$jpg = "https://m.momoshop.com.tw/ecm/img/online/app/limitbuy/".$dir."/".$fsCode.".jpg";
						$link = "http://m.momoshop.com.tw/goods.momo?i_code=".$goodsCode;

						// echo "[goods2_limit][$i] $name $goodsCode -> $jpg -> $picture\n";
						curl( $jpg , "【$type goods2_limit】$goodsCode $name 限時搶購 圖片錯誤" );
						curl( $link, "【$type goods2_limit】$goodsCode $name 限時搶購 連結錯誤" );
						break;

					case 11: // goods2_normal
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name      = $info[$i]->{"mainGoods"}->{"name"};
						$picture   = $info[$i]->{"mainGoods"}->{"picture"};
						if( strlen($goodsCode)==6 || strlen($goodsCode)==7 )
							$link = "http://m.momoshop.com.tw/goods.momo?i_code=".$goodsCode;
						else
							$link = $goodsCode;
						// echo "[goods2_normal][$i] $name -> $picture -> $link\n";
						curl( $picture , "【$type goods2_normal】今日秒殺 $name 圖片錯誤" );
						curl( $link    , "【$type goods2_normal】$name 今日秒殺 連結錯誤" );
						break;

					case 12: // goods3 電視購物
						if( !isset($info[$i]->{"mainGoods"}->{"goodsCode"}) )
							break;
						$goodsCode = $info[$i]->{"mainGoods"}->{"goodsCode"};
						$name     = $info[$i]->{"mainGoods"}->{"name"};
						$picture  = $info[$i]->{"mainGoods"}->{"picture"};
						$link = "http://m.momoshop.com.tw/goods.momo?i_code=".$goodsCode;
						// echo "[goods2_normal][$i] $name -> $picture -> $link\n";
						curl( $picture , "【$type goods3】$goodsCode $name 電視購物 圖片錯誤" );
						curl( $link    , "【$type goods3】$goodsCode $name 電視購物 商品頁 連結錯誤" );
						break;

					case 13: // other 最下方促銷商品
						if( !isset($info[$i]->{"banner"}->{"picture"}) )
							break;
						$picture = $info[$i]->{"banner"}->{"picture"};
						$link    = $info[$i]->{"action"}->{"actionValue"};
						// echo "[other][$i] $picture -> $link\n";
						curl( $picture , "【$type 最下方促銷商品】圖片錯誤" );
						curl( $link    , "【$type 最下方促銷商品】連結錯誤" );
						
						break;

				}
				//echo "\n";
			}
		}
	}
}
curl_close($ch);
redis_close();
exit;
 
function curl_post_call($url,$data)
{
    $headers= array('Accept: application/json','Content-Type: application/json');
    $handle=curl_init();
    curl_setopt($handle, CURLOPT_URL, $url);
    curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($handle, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($handle, CURLOPT_POST, true);
    curl_setopt($handle, CURLOPT_POSTFIELDS, $data);
     
    $response= curl_exec($handle);
    $code= curl_getinfo($handle,CURLINFO_HTTP_CODE);
     
    return $response;
}

	function curl( $url="", $msg="" )
	{
		global $ch;
		if( $url=="" || $msg=="" )
			return "";

		// 如果有發生錯誤 , key 存在10分鐘內不檢查
   	$key = "ecapp:".$url;
  	if( redis_exists($key) )
  		return;
		
  	curl_setopt($ch, CURLOPT_URL, $url );
  	curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 6);
		curl_setopt($ch, CURLOPT_TIMEOUT, 6);
    curl_setopt($ch, CURLOPT_POST, 0 );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLINFO_HEADER_OUT, 1); // capture the header info
		curl_setopt($ch, CURLOPT_VERBOSE, 1); // turn verbose on
    curl_setopt($ch, CURLOPT_COOKIEJAR, "COOKIEJAR");
    
    $result = curl_exec($ch);
    
		$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    
    if( $httpCode!=200 )
    {
    	$msg = "httpCode=".$httpCode."\n".$msg."\n".$url;
    	sendGCM( $msg );
    	echo $msg."\n";
    	
    	// 將錯誤的url記錄600秒
			redis_set( $key, $msg, 600 );
    }

    return $result;
	}

	function sendGCM( $message="" )
	{
		if( $message=="" )
			return;

		$senderId   = "ecapp00";
		$senderName = "ecapp首頁監控";
		$empId      = "01170";

    // 發送GCM
    $headers = array("Content-Type: application/x-www-form-urlencoded");
   
    $para = "TAG=sendEMP";
    $para.= "&senderId=".$senderId;
    $para.= "&senderName=".urlencode($senderName);
    $para.= "&emp_id=".$empId;
    $para.= "&message=".urlencode($message);

		//echo $para."\n\n";
		
    $ch = curl_init();
    curl_setopt( $ch, CURLOPT_URL, "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT" );
    curl_setopt( $ch, CURLOPT_POST, true );
    curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

    curl_setopt( $ch, CURLOPT_POSTFIELDS, $para );
    $result = curl_exec($ch);
    curl_close($ch);
    return $result;
	}

?>