<?
	include "funclib.php";
	include "redisFunc.php";

	//----------------------------------------------------------------------------------------------------------------------
	// 先載入 keyword 定義
	//----------------------------------------------------------------------------------------------------------------------
	$keyword = "/php/ptt/keyword.txt";
	if( !($fp=fopen($keyword,"r")) )
		exit;
	
	$aKeyWord = array();
	while( !feof($fp) )
	{
		$str = trim(fgets($fp,128));
		if( $str=="" )
			continue;
			
		if( !isset($aKeyWord[$str]) )
			array_push($aKeyWord, $str);
	}
	fclose($fp);

	$today = time();
	redis_conn();
	$ch = curl_init();
	
	//----------------------------------------------------------------------------------------------------------------------
	// 取出即時新聞標題
	//----------------------------------------------------------------------------------------------------------------------
	
	$html = getURL($ch,"https://www.setn.com/ViewAll.aspx");

	// 第一個開頭 新聞列表
	$n = strpos($html,"<div class=\"row NewsList\">");
	$html = substr($html,$n);

	// 找出第1個結尾
	$n = strpos($html,"<script>");
	$html = substr($html,0,$n);

	// 找出第2個結尾
	$n = strpos($html,"<div class=\"row\">");
	$html = substr($html,0,$n);

	$aa = explode("<div class=\"col-sm-12\">",$html);
	foreach( $aa as $html )
	{
		$id = $kind = $title = $time = $url = "";
		parsingHTML($html, $id, $kind, $title, $time, $url );
		if( $id=="" || $kind=="" || $title=="" || $time=="" || $url=="" )
			continue;

		$key = "newsSETN:".$id;
		// 3天內的 先檢查 key 是否存在
		if( redis_exists($key) )
			continue;

		// 新PO文章 從這裡開始
		// 寫入redis, 避免下次再檢查
		redis_set($key,"");

		echo $time." ".$id." ".$title." ".$kind." ".$url."\n";
		
		$html = getContent($ch, $url);
		
		// 要過濾關鍵字
		$flag = false;
		$ids = "";
		
		// 尋找關鍵字 momo 富邦 包含 link 都找
		$aKey = array("momo","ｍｏｍｏ","富邦購物","摩天商城","富邦媒","標錯價");
		$word = search_Keyword( $aKey, $html, $title );
		if( $word!="" )
		{
			$ids = "momo_keyword";
			$flag = true;

			$gcmMsg = $url;
			$ok = sendGCM_news( "newsSETN", $ids, $gcmMsg, $time."【".$kind."】".$word."\n標題:".$title );
			echo date("Y/m/d H:i:s")." $time ---> [$time] [$kind] $word --> $url [$ok]\n\n";
		}
		else
		{
			// 尋找 自訂關鍵字 keyword.txt 
			$word = search_Keyword( $aKeyWord, $html, $title );
			if( $word!="" )
			{
				//     鄭仁智
				$ids = "01170";
				$flag = true;
				
				if( $word=="汐止" )
				{
					//     鄭仁智 倪其伸
					$ids = "01170,04228";
				}
				elseif( $word=="pchome" || $word=="物流" )
				{
					// 04369 王莉蓉
					$ids = "04369";
				}
				
				$gcmMsg = $url;
				$ok = sendGCM_news( "newsSETN", $ids, $gcmMsg, $time."【".$kind."】".$word."\n標題:".$title );
				echo date("Y/m/d H:i:s")." $time ---> [$time] [$kind] $word --> $url [$ok]\n\n";
			}
		}				
	}
	
	curl_close($ch);
	redis_close();

	exit;

	
	function parsingHTML($html, &$id, &$kind, &$title, &$time, &$url )
	{
		// 取出時間1
		if( ($n=strpos($html,"<time style="))<1 ) return;
		$html = substr($html,$n+9);

		// 取出時間2
		if( ($n=strpos($html,">"))<1 ) return;
		$html = substr($html,$n+1);

		// 取出時間3
		if( ($n=strpos($html," "))<1 ) return;
		$html = substr($html,$n+1);
		$time = substr($html,0,5);
		
		// 取出類別1
		if( ($n=strpos($html,"<a href=\""))<1 ) return;
		$html = substr($html,$n);

		// 取出類別2
		if( ($n=strpos($html,">"))<1 ) return;
		$html = substr($html,$n+1);

		// 取出類別2
		if( ($n=strpos($html,"<"))<1 ) return;
		$kind = substr($html,0,$n);
		$html = substr($html,$n+1);
		
		// 取出url連結1
		if( ($n=strpos($html," href=\""))<1 ) return;
		$html = substr($html,$n+7);

		// 取出url連結2
		if( ($n=strpos($html,"\""))<1 ) return;
		$url = "https://www.setn.com".substr($html,0,$n);
		$html = substr($html,$n+1);

		// 取出文章ID1
		if( ($n=strrpos($url,"="))<1 ) return;
		$id = substr($url,$n+1);

		// 取出標題1
		if( ($n=strpos($html,">"))<1 ) return;
		$html = substr($html,$n+1);

		// 取出標題2
		if( ($n=strpos($html,"<"))<1 ) return;
		$title = substr($html,0,$n);
		$title = str_replace("　"," ",$title);
		
		// echo $time." ".$kind." ".$id." ".$title." ".$url."\n".$html."\n";
	}

	function getURL($ch, $url)
	{
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36");
		curl_setopt($ch, CURLOPT_REFERER, 'https://www.setn.com/');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch, CURLOPT_COOKIEJAR, "/php/news_setn/COOKIEJAR");
		curl_setopt($ch, CURLOPT_COOKIE, "over18=1");
		curl_setopt($ch, CURLOPT_URL, $url);
		$html = trim(curl_exec($ch));
		return $html;
	}

	function getContent($ch, $url)
	{
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36");
		curl_setopt($ch, CURLOPT_REFERER, 'https://www.setn.com/');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch, CURLOPT_COOKIEJAR, "/php/news_setn/COOKIEJAR");
		curl_setopt($ch, CURLOPT_COOKIE, "over18=1");
		curl_setopt($ch, CURLOPT_URL, $url);
		$html = trim(curl_exec($ch));
		if( $html=="" )
			return;
		
		// 文章開頭1
		$n = strpos($html,"<article");
		$html = substr($html,$n);
		
		// 文章結尾1
		if( ($n=strpos($html,"</article"))>0 )
			$html = substr($html,0,$n);

		// 轉成純文字
		$html = strip_tags($html);
		
		// 去除 空白 換行 符號
		$html = str_replace("\n","",$html);
		$html = str_replace("\t","",$html);
		$html = str_replace(" ","",$html);
		$html = str_replace("　","",$html);
		
		$html = str_replace("&nbsp;","",$html);
		$html = str_replace("&#33;","!" ,$html);
		$html = str_replace("&#34;","\"",$html);
		$html = str_replace("&#35;","#" ,$html);
		$html = str_replace("&#36;","$" ,$html);
		$html = str_replace("&#37;","%" ,$html);
		$html = str_replace("&#38;","&" ,$html);
		$html = str_replace("&#39;","'" ,$html);
		$html = str_replace("&amp;","&" ,$html);

		$html = str_replace("&#033;","!" ,$html);
		$html = str_replace("&#034;","\"",$html);
		$html = str_replace("&#035;","#" ,$html);
		$html = str_replace("&#036;","$" ,$html);
		$html = str_replace("&#037;","%" ,$html);
		$html = str_replace("&#038;","&" ,$html);
		$html = str_replace("&#039;","'" ,$html);
		$html = str_replace("&lt;"  ,"<" ,$html);
		$html = str_replace("&gt;"  ,">" ,$html);
		
		return $html;
	}

	function sendGCM_news( $sender="", $empId="", $message="", $subject="" )
	{
		if( $sender=="" || $empId=="" || $message=="" )
			return;

		// $empId = "01170";

		$senderId = $sender;
		switch( $sender )
		{
			case "newsSETN":
				$senderName = "三立新聞網";
				break;
			default:
				return;
				break;
		}

    // 發送GCM
    $headers = array("Content-Type: application/x-www-form-urlencoded");
   
  	$para = "TAG=".urlencode("sendEMP_HTML");
    $para.= "&senderId=".urlencode($senderId);
    $para.= "&senderName=".urlencode($senderName);
    $para.= "&emp_id=".urlencode($empId);
    $para.= "&subject=".urlencode($subject);
    $para.= "&redirect=".urlencode( $message );

		// echo "\n\n".$para."\n\n";
		
		$result = "";
		$hh = intval( date("H") );
		if( $hh>7 && $hh<23 )
		{
	    $ch = curl_init();
	    curl_setopt( $ch, CURLOPT_URL, "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT&FROM=".$senderId );
	    curl_setopt( $ch, CURLOPT_POST, true );
	    curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
	    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

	    curl_setopt( $ch, CURLOPT_POSTFIELDS, $para );
	    $result = curl_exec($ch);
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);	    
	    curl_close($ch);
	    
	    if( $result!=200 )
	    	echo "httpCode=$httpCode $result\n";
  	}
  	else // 放入 redis 等到7:00排成起來再發送
  	{
			$key = "gcm:queue:count";
			if( ($id=redis_incr($key))>0 )
			{
				// 設定存放10小時
				$key = "gcm:queue:$id:message";
				redis_set( $key, $para, 36000);
				$result = "queue";
			}
  	}
    return $result;
	}

	
	
?>
