<?
	include "funclib.php";
	include "redisFunc.php";

	//----------------------------------------------------------------------------------------------------------------------
	// 先載入 keyword 定義
	//----------------------------------------------------------------------------------------------------------------------
	$keyword = "/php/ptt/keyword.txt";
	if( !($fp=fopen($keyword,"r")) )
		exit;
	
	$aKeyWord = array();
	while( !feof($fp) )
	{
		$str = trim(fgets($fp,128));
		if( $str=="" )
			continue;
			
		if( !isset($aKeyWord[$str]) )
			array_push($aKeyWord, $str);
	}
	fclose($fp);

	$today = time();
	redis_conn();
	$ch = curl_init();
	
	//----------------------------------------------------------------------------------------------------------------------
	// 取出即時新聞標題
	//----------------------------------------------------------------------------------------------------------------------
	
	$html = getURL($ch,"https://udn.com/news/breaknews/1");
	
	//$html = curl("https://udn.com/news/breaknews/");
	$n = strpos($html,"<div id=\"breaknews_body\"");
	$html = substr($html,$n);

	$n = strpos($html,"<dt class=\"only_mobile");
	$html = substr($html,0,$n);

	// 找出第一個h2
	$n = strpos($html,"<dl>");
	$html = substr($html,$n);

	$time = date("H:i");
	
	$aa = explode("</h2>",$html);
	// 找出第一個h2
	foreach( $aa as $html )
	{
		// 取出類別
		$n = strpos($html,"class=\"cate\">");
		$html = substr($html,$n+13);

		$n = strpos($html,"</a>");
		$kind = substr($html,0,$n);
		
		$n = strpos($html,"<h2>");
		$html = substr($html,$n+4);
		if( substr($html,0,2)!="<a" )
			continue;


		// 找出列表的url
		$n = strpos($html,"href=\"");
		$html = substr($html,$n+6);

		// 找出列表的url的結尾
		$n = strpos($html,"\"");
		$url = substr($html,0,$n);
		$html = substr($html,$n+2);
		
		// 找出title
		$n = strpos($html,">");
		$html = substr($html,$n+1);

		// 找出title
		$n = strpos($html,"</a>");
		$title = substr($html,0,$n);
		
		// 將url轉成 redis_key
		$n = strrpos($url,"?");
		$html = substr($url,0,$n);
		
		$key = str_replace("/news/story/","",$html);
		$key = "newsUDN:".str_replace("/",":",$key);

		// 3天內的 先檢查 key 是否存在
		if( redis_exists($key) )
			continue;

		// 新PO文章 從這裡開始
		// 寫入redis, 避免下次再檢查
		redis_set($key,"");
		
		echo $kind." ".$key." https://udn.com".$url." ".$title."\n\n";
		
		$html = getContent($ch, "https://udn.com".$url);
		
		// 要過濾關鍵字
		$flag = false;
		$ids = "";
		
		// 尋找關鍵字 momo 富邦 包含 link 都找
		$aKey = array("momo","ｍｏｍｏ","富邦購物","摩天商城","富邦媒","標錯價");
		$word = search_Keyword( $aKey, $html, $title );
		if( $word!="" )
		{
			$ids = "momo_keyword";
			$flag = true;

			$gcmMsg = "https://udn.com".$url;
			$ok = sendGCM_news( "newsUDN", $ids, $gcmMsg, $time."【".$kind."】$word\n標題:".$title );
			echo date("Y/m/d H:i:s")." $time ---> $time [$kind] $word --> $url [$ok]\n\n";
		}
		else
		{
			// 尋找 自訂關鍵字 keyword.txt 
			$word = search_Keyword( $aKeyWord, $html, $title );
			if( $word!="" )
			{
				//     鄭仁智
				$ids = "01170";
				$flag = true;
				
				if( $word=="汐止" )
				{
					//     鄭仁智 倪其伸
					$ids = "01170,04228";
				}
				elseif( $word=="pchome" || $word=="物流" )
				{
					// 04369 王莉蓉
					$ids = "04369";
				}
				
				$gcmMsg = "https://udn.com".$url;
				$ok = sendGCM_news( "newsUDN", $ids, $gcmMsg, $time."【".$kind."】$word\n標題:".$title );
				echo date("Y/m/d H:i:s")." $time ---> $time [$kind] $word --> $url [$ok]\n\n";
			}
		}		
		
	}
	// var_dump($aa);


	curl_close($ch);
	redis_close();

	exit;

	function getURL($ch, $url)
	{
		//$url = "https://udn.com/news/breaknews/";
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36");
		curl_setopt($ch, CURLOPT_REFERER, 'https://udn.com/news/index');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch, CURLOPT_COOKIEJAR, "/php/news_udn/COOKIEJAR");
		curl_setopt($ch, CURLOPT_COOKIE, "over18=1");
		curl_setopt($ch, CURLOPT_URL, $url);
		$html = trim(curl_exec($ch));
		return $html;
	}

	function getContent($ch, $url)
	{
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36");
		curl_setopt($ch, CURLOPT_REFERER, 'https://udn.com/news/breaknews/1');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch, CURLOPT_COOKIEJAR, "/php/news_udn/COOKIEJAR");
		curl_setopt($ch, CURLOPT_COOKIE, "over18=1");
		curl_setopt($ch, CURLOPT_URL, $url);
		$html = trim(curl_exec($ch));
		if( $html=="" )
			return;
		
		// 文章開頭
		$n = strpos($html,"<!-- /#story_bady_info -->");
		$html = substr($html,$n);
		
		// 文章結尾1
		if( ($n=strpos($html,"<figure "))>0 )
			$html = substr($html,0,$n);

		// 文章結尾2
		if( ($n=strpos($html,"<div class=\"photo_pop\">"))>0 )
			$html = substr($html,0,$n);

		// 文章結尾3
		if( ($n=strpos($html,"<!-- /#story_body_content -->"))>0 )
			$html = substr($html,0,$n);

		// 轉成純文字
		$html = strip_tags($html);
		
		// 去除 空白 換行 符號
		$html = str_replace("\n","",$html);
		$html = str_replace("\t","",$html);
		$html = str_replace(" ","",$html);
		$html = str_replace("　","",$html);
		
		$html = str_replace("&nbsp;","",$html);
		$html = str_replace("&#33;","!" ,$html);
		$html = str_replace("&#34;","\"",$html);
		$html = str_replace("&#35;","#" ,$html);
		$html = str_replace("&#36;","$" ,$html);
		$html = str_replace("&#37;","%" ,$html);
		$html = str_replace("&#38;","&" ,$html);
		$html = str_replace("&#39;","'" ,$html);
		$html = str_replace("&amp;","&" ,$html);

		$html = str_replace("&#033;","!" ,$html);
		$html = str_replace("&#034;","\"",$html);
		$html = str_replace("&#035;","#" ,$html);
		$html = str_replace("&#036;","$" ,$html);
		$html = str_replace("&#037;","%" ,$html);
		$html = str_replace("&#038;","&" ,$html);
		$html = str_replace("&#039;","'" ,$html);
		$html = str_replace("&lt;"  ,"<" ,$html);
		$html = str_replace("&gt;"  ,">" ,$html);
		
		return $html;
	}

	function sendGCM_news( $sender="", $empId="", $message="", $subject="" )
	{
		if( $sender=="" || $empId=="" || $message=="" )
			return;

		// $empId = "01170";

		$senderId = $sender;
		switch( $sender )
		{
			case "newsUDN":
				$senderName = "聯合新聞";
				break;
			default:
				return;
				break;
		}

    // 發送GCM
    $headers = array("Content-Type: application/x-www-form-urlencoded");
   
   	if( $subject=="" )
   	{
				// 如果是 AWS_CDN message 加上 時間
				if( $senderId=="AWS_CDN" )
					$aaa = date("Y/m/d H:i:s")."\n".$aaaa;

    	$para = "TAG=sendEMP";
	    $para.= "&senderId=".$senderId;
	    $para.= "&senderName=".urlencode($senderName);
	    $para.= "&emp_id=".$empId;
	    $para.= "&message=".urlencode($message);
    }
    else
    {
    	$para = "TAG=".urlencode("sendEMP_HTML");
	    $para.= "&senderId=".urlencode($senderId);
	    $para.= "&senderName=".urlencode($senderName);
	    $para.= "&emp_id=".urlencode($empId);
	    $para.= "&subject=".urlencode($subject);
	    $para.= "&redirect=".urlencode( $message );
	  }

		// echo "\n\n".$para."\n\n";
		
		$result = "";
		$hh = intval( date("H") );
		if( $hh>7 && $hh<23 )
		{
	    $ch = curl_init();
	    curl_setopt( $ch, CURLOPT_URL, "http://ec-monitor.fmt.com.tw:1688/gcm/service.php?ID=momoIT&FROM=".$senderId );
	    curl_setopt( $ch, CURLOPT_POST, true );
	    curl_setopt( $ch, CURLOPT_HTTPHEADER, $headers );
	    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );

	    curl_setopt( $ch, CURLOPT_POSTFIELDS, $para );
	    $result = curl_exec($ch);
			$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);	    
	    curl_close($ch);
	    
	    if( $result!=200 )
	    	echo "httpCode=$httpCode $result\n";
  	}
  	else // 放入 redis 等到7:00排成起來再發送
  	{
			$key = "gcm:queue:count";
			if( ($id=redis_incr($key))>0 )
			{
				// 設定存放10小時
				$key = "gcm:queue:$id:message";
				redis_set( $key, $para, 36000);
				$result = "queue";
			}
  	}
    return $result;
	}

	
	
?>
