<?
	$memcache = null;

	//--------------------------------------------------
	// memcached function
	//--------------------------------------------------
	function memcached_open()
	{
		global $memcache;
		$memcache = new Memcache();
		$memcache->connect("127.0.0.1",11211);
	}

	function memcached_close()
	{
		global $memcache;
		if( $memcache )
			$memcache->close();
	}
	
	// memcache
	function memcached_get( $key="" )
	{
		global $memcache;
		$val = "";
		
		if( $key=="" )
			return $val;
		
		if( $memcache )
			$val = $memcache->get($key);
			
		return $val;
	}

	function memcached_set( $key="", $val="", $timeout=0 )
	{
		global $memcache;

		if( $key=="" )
			return;
		
		if( $memcache )
		{
			$memcache->set($key,$val, 0, $timeout);
			//echo "$key v=$val\n";
		}
	}

	function memcached_add( $key="", $n=1 )
	{
		global $memcache;
		
		if( $key=="" )
			return;
			
		$val = "";
		if( $memcache )
			$val = $memcache->increment($key,$n);
			
		return $val;
	}


	function memcached_del( $key="" )
	{
		global $memcache;
		
		if( $key=="" )
			return;
			
		if( $memcache )
			$val = $memcache->delete($key);
			
		return $val;
	}

?>